diff --git a/plugins/dell/fu-dell-common.c b/plugins/dell/fu-dell-common.c
index 4b8366b2840..b16441c8128 100644
--- a/plugins/dell/fu-dell-common.c
+++ b/plugins/dell/fu-dell-common.c
@@ -160,8 +160,6 @@ fu_dell_detect_dock (FuDellSmiObj *smi_obj, guint32 *location)
 		return FALSE;
 	}
 	*location = count_out->location;
-	g_debug ("Dock count %u, location %u.",
-		 count_out->count, *location);
 	return TRUE;
 }
 
diff --git a/plugins/dell/fu-plugin-dell.c b/plugins/dell/fu-plugin-dell.c
index a5e09a65549..a5fae3caec0 100644
--- a/plugins/dell/fu-plugin-dell.c
+++ b/plugins/dell/fu-plugin-dell.c
@@ -302,7 +302,6 @@ fu_plugin_dell_device_added_cb (GUsbContext *ctx,
 	efi_guid_t guid_raw;
 	efi_guid_t tmpguid;
 	gboolean old_ec = FALSE;
-	g_autofree gchar *fw_str = NULL;
 
 	/* don't look up immediately if a dock is connected as that would
 	   mean a SMI on every USB device that showed up on the system */
@@ -342,6 +341,7 @@ fu_plugin_dell_device_added_cb (GUsbContext *ctx,
 	parse_flags = fu_plugin_dell_get_version_format ();
 
 	for (guint i = 0; i < dock_info->component_count; i++) {
+		g_autofree gchar *fw_str = NULL;
 		if (i >= MAX_COMPONENTS) {
 			g_debug ("Too many components.  Invalid: #%u", i);
 			break;
@@ -386,6 +386,7 @@ fu_plugin_dell_device_added_cb (GUsbContext *ctx,
 
 	/* if an old EC or invalid EC version found, create updatable parent */
 	if (old_ec) {
+		g_autofree gchar *fw_str = NULL;
 		tmpguid = DOCK_FLASH_GUID;
 		fw_str = as_utils_version_from_uint32 (dock_info->flash_pkg_version,
 						       parse_flags);
@@ -408,7 +409,6 @@ fu_plugin_dell_device_removed_cb (GUsbContext *ctx,
 {
 	FuPluginData *data = fu_plugin_get_data (plugin);
 	FuPluginDockItem *item;
-	g_autofree gchar *dock_key = NULL;
 	const efi_guid_t guids[] = { WD15_EC_GUID, TB16_EC_GUID, TB16_PC2_GUID,
 				     TB16_PC1_GUID, WD15_PC1_GUID,
 				     LEGACY_CBL_GUID, UNIV_CBL_GUID,
@@ -417,8 +417,6 @@ fu_plugin_dell_device_removed_cb (GUsbContext *ctx,
 	guint16 pid;
 	guint16 vid;
 
-	g_autofree gchar *guid_str = NULL;
-
 	if (!data->smi_obj->fake_smbios) {
 		vid = g_usb_device_get_vid (device);
 		pid = g_usb_device_get_pid (device);
@@ -433,6 +431,8 @@ fu_plugin_dell_device_removed_cb (GUsbContext *ctx,
 
 	/* remove any components already in database? */
 	for (guint i = 0; i < G_N_ELEMENTS (guids); i++) {
+		g_autofree gchar *dock_key = NULL;
+		g_autofree gchar *guid_str = NULL;
 		guid_raw = &guids[i];
 		guid_str = g_strdup ("00000000-0000-0000-0000-000000000000");
 		efi_guid_to_str (guid_raw, &guid_str);
diff --git a/plugins/dell/fu-self-test.c b/plugins/dell/fu-self-test.c
index 01b557f7887..51a2927ae9e 100644
--- a/plugins/dell/fu-self-test.c
+++ b/plugins/dell/fu-self-test.c
@@ -40,7 +40,9 @@ static void
 _plugin_device_added_cb (FuPlugin *plugin, FuDevice *device, gpointer user_data)
 {
 	FuDevice **dev = (FuDevice **) user_data;
-	*dev = g_object_ref (device);
+	/* only update reference once */
+	if (*dev == NULL)
+		*dev = g_object_ref (device);
 }
 
 static void
@@ -117,6 +119,8 @@ fu_plugin_dell_tpm_func (void)
 	/* cleanup */
 	fu_plugin_device_remove (plugin, device_alt);
 	fu_plugin_device_remove (plugin, device);
+	g_clear_object (&device);
+	g_clear_object (&device_alt);
 
 	/* inject fake data:
 	 * - that hasflashes
@@ -148,6 +152,8 @@ fu_plugin_dell_tpm_func (void)
 	/* cleanup */
 	fu_plugin_device_remove (plugin, device_alt);
 	fu_plugin_device_remove (plugin, device);
+	g_clear_object (&device);
+	g_clear_object (&device_alt);
 
 	/* inject fake data:
 	 * - that has flashes
@@ -186,6 +192,8 @@ fu_plugin_dell_tpm_func (void)
 	/* cleanup */
 	fu_plugin_device_remove (plugin, device_alt);
 	fu_plugin_device_remove (plugin, device);
+	g_clear_object (&device);
+	g_clear_object (&device_alt);
 
 	/* inject fake data:
 	 * - that has 1 flash left
@@ -227,6 +235,8 @@ fu_plugin_dell_tpm_func (void)
 	/* cleanup */
 	fu_plugin_device_remove (plugin, device_alt);
 	fu_plugin_device_remove (plugin, device);
+	g_clear_object (&device);
+	g_clear_object (&device_alt);
 }
 
 static void
@@ -307,10 +317,10 @@ fu_plugin_dell_dock_func (void)
 	fu_plugin_dell_device_added_cb (NULL, NULL,
 					  plugin);
 	g_assert (device != NULL);
-	device = NULL;
 	g_free (buf.record);
 	fu_plugin_dell_device_removed_cb (NULL, NULL,
 					    plugin);
+	g_clear_object(&device);
 
 	/* inject valid TB16 dock w/ older system EC */
 	buf.record = g_malloc0 (sizeof(DOCK_INFO_RECORD));
@@ -344,10 +354,10 @@ fu_plugin_dell_dock_func (void)
 	fu_plugin_dell_device_added_cb (NULL, NULL,
 					  plugin);
 	g_assert (device != NULL);
-	device = NULL;
 	g_free (buf.record);
 	fu_plugin_dell_device_removed_cb (NULL, NULL,
 					    plugin);
+	g_clear_object(&device);
 
 
 	/* inject valid WD15 dock w/ invalid flash pkg version */
@@ -379,10 +389,10 @@ fu_plugin_dell_dock_func (void)
 	fu_plugin_dell_device_added_cb (NULL, NULL,
 					  plugin);
 	g_assert (device != NULL);
-	device = NULL;
 	g_free (buf.record);
 	fu_plugin_dell_device_removed_cb (NULL, NULL,
 					    plugin);
+	g_clear_object(&device);
 
 
 	/* inject valid WD15 dock w/ older system EC */
@@ -414,10 +424,10 @@ fu_plugin_dell_dock_func (void)
 	fu_plugin_dell_device_added_cb (NULL, NULL,
 					  plugin);
 	g_assert (device != NULL);
-	device = NULL;
 	g_free (buf.record);
 	fu_plugin_dell_device_removed_cb (NULL, NULL,
 					    plugin);
+	g_clear_object(&device);
 
 	/* inject an invalid future dock */
 	buf.record = g_malloc0 (sizeof(DOCK_INFO_RECORD));
